#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "TPager.h"
#include "rman.h"

int ehandler(d, e){
/*
    Dummy function
*/
}

void GetCfgName(unsigned char *cfgname, unsigned char *rootcfgname)
{
	strcpy(cfgname, getenv("HOME"));
	strcat(cfgname, "/.rose");

	strcpy(rootcfgname, "/usr/jtool/bin/.rose");
}

void Bell(Display *display, Window window, int BELL)
/*
    ٥Ĥ餹
    BELL = 0        ⤷ʤ
    BELL = 1        ӡײĤ餹
    BELL = 2        ӥ奢٥
*/
{
    switch (BELL){
        case    0:  break;
        case    1:  XBell(display, 0);
                    break;
        case    2:  XClearArea(display, window, 0, 0, 1, 1, True);
    }
}

void SetFontSet(Display *display, char *ankfont, char *kanjifont, XFontSet *FS)
/*
    ankfontkanjifontեȥåFS
*/
{
    unsigned char   buf[256];
    char            **miss, *def;
    int             n_miss;

    strcpy(buf, ankfont);
    strcat(buf, ",");
    strcat(buf, kanjifont);
    *FS =  XCreateFontSet(display, buf, &miss, &n_miss, &def);
}

int GetFontSize(Display *display, char *font_name)
/*
    ꤵ줿եȤβ֤
*/
{
    XFontStruct     *fonts;

    fonts = XLoadQueryFont(display, font_name);
    return fonts->min_bounds.width;
}

int Tab2Spc(int Tab, unsigned char *str1, unsigned char *str2)
/*
    ֤򥹥ڡѴ
    [Return] ڡѴʸ
*/
{
    int     locate = 0;
    int     i;

    while( *str1 != NULL ){
        if ( *str1 == '	' ){
            for ( i = locate ; i <= (locate/Tab)*Tab + Tab - 1 ; i++ ){
                *str2++ = ' ';
            }
            locate = (locate/Tab)*Tab + Tab;
            str1++;
        }else{
            *str2 = *str1;
            locate++;
            str1++;
            str2++;
        }
    }
    *str2 = NULL;
    return locate;
}

int ClearBuffer(struct PAGER *Pager, int MaxLine)
{
	int		i;

	for ( i = 0 ; i < MaxLine ; i++ ){
		Pager->buff[i][0] = 0;
	}
}

int FileRead(FILE *fp, struct PAGER *Pager, int MaxLine, int Tab, int sjis)
{
	int				CR_flg;			/* ˲ԤȤ1 */
	int				pp;
	int				i;
	unsigned char	buf[512];
	unsigned char	SpcStr[1024];

	Pager->lines=0;
	i = 0; CR_flg = 0;
	while (fgets(buf, Pager->LINELEN + 1, fp) != NULL){
		if (CR_flg == 1 && buf[0] == 0x0a){	
			CR_flg = 0;
			continue;
		}
		if (strlen(buf) == Pager->LINELEN){
			CR_flg = 1;
		}else{
			CR_flg = 0;
		}
		pp = 0;
		Tab2Spc(Tab, buf, SpcStr);
		while(1){
			if (sjis){
				sjistoeuc(Pager->buff[i],Pager->LINELEN,SpcStr,strlen(SpcStr));
			}else{
				strncpy(Pager->buff[i], &SpcStr[pp], Pager->LINELEN);
			}
			/*
			strncpy(Pager->buff[i], &SpcStr[pp], Pager->LINELEN);
			*/
			Pager->buff[i][Pager->LINELEN+1] = NULL;
			pp += strlen(Pager->buff[i]);
			if (pp >= strlen(SpcStr)) break;

			i++; Pager->lines++;
			if (Pager->lines >= MaxLine){
				/*
				fprintf(stderr, "ե륵礭ɤޤ\n");
				*/
				return 1;
				/*
				exit(1);
				*/
			}
		}
		i++; Pager->lines++;
		if (Pager->lines >= MaxLine){
		/*
			fprintf(stderr, "ե륵礭ɤޤ\n");
			*/
			return 1;
			/*
			exit(1);
			*/
		}
	}
}

GetFontNoFromSize(struct FontNameSet *FNSet, int size)
{
	int		i;

	i = 0;
	while (FNSet[i].size != 0){
		if (FNSet[i].size == size) return i;
		i++;
	}
	return 0;
}

GetOption1(int argc, char *argv[], char *disname, char *cfgname, char *rootcfgname)
{
	int		i;

	*disname = NULL;

	for ( i=1 ; i<=argc-1 ; i++ ){
		if (!strncmp(argv[i], "-display=", 9)) {
			strcpy(disname, &argv[i][9]);
		}
		if (!strncmp(argv[i], "-cfg=", 5)) {
			strcpy(cfgname, &argv[i][5]);
		}
		if (!strncmp(argv[i], "-rcfg=", 6)) {
			strcpy(rootcfgname, &argv[i][6]);
		}
	}
}
#ifdef nodef
Main(Display *display, struct PAGER *Pager, struct SCROLL *Scroll, struct MENUWIN *MenuWin, XEvent *event, struct MENU *Menu, struct FileSet *FSet, char *rootcfgname, struct RMAN *RMan)
{
	int		no;

	if (event->type == ClientMessage){
		if (event->xclient.message_type == XInternAtom(display, "Main-Exit", False)){
			exit(0);
		}
		if (event->xclient.message_type == XInternAtom(display, "Main-ChangeText", False)){
			no = event->xclient.data.l[0];

			if (FSet[no].file_table != 1){
				Bell(display, Pager->window, Pager->BELL);
				return;
			}
			if (Menu[no].type == 1){
				ReadConfigFile2(rootcfgname, Menu[no].name, &(MenuWin->file_last_no), MenuWin->titlemes);
				MenuWin->file_no = 0;
				Pager->pos = 0;
				SendMenuAllDraw(display, MenuWin->sw[0]);
			} else{
				FSet[MenuWin->file_no].file_pos = Pager->pos;
				MenuWin->file_no = no;
				SendMenuAllDraw(display, MenuWin->sw[0]);
			}
			Initialize(display, Pager, Scroll, MenuWin, RMan, Menu, FSet);
			return;
		}
	}
}
#endif
NoManual(struct PAGER *Pager)
{
	int		i;

	Pager->lines = 2;
	Pager->pos = 0;
	/*
	strcpy( Pager->buff[0], "ޤޥ˥奢뤬ޤ");
	strcpy( Pager->buff[1], "˥󥯥Ȥޤ");
	*/
	strcpy( Pager->buff[0], NoMan1);
	strcpy( Pager->buff[1], NoMan2);

	for ( i = 2 ; i <= Pager->LINES ; i++ ){
		Pager->buff[i][0] = 0;
	}
}

int FileOpen(FILE **fp, char *file_no, struct PAGER *Pager, struct RMAN *RMan, struct MENU *Menu, struct FileSet *FSet)
{
	static int	fopenFLG = 0;

	/*  եΥץ  */
	if (Menu[*file_no].type == 1){
		Pager->lines = 0;
		Pager->pos = 0;
		return 1;
	}

	if (fopenFLG == 1){
		fclose(*fp);
	}

	if ((*fp=fopen(FSet[*file_no].filename, "r"))==NULL){
		NoManual(Pager);
		fopenFLG = 0;
		return 1;
	}
	fopenFLG = 1;
	return 0;
}

Initialize(Display *display, struct PAGER *Pager,struct SCROLL *Scroll, struct MENUWIN *MenuWin, struct RMAN *RMan, struct MENU *Menu, struct FileSet *FSet)
{
	static FILE		*fp;

	/*
	printf("MaxLine = %d\n", RMan->MaxLine);
	*/
	ClearBuffer(Pager, RMan->MaxLine);

	/*  եΥץ  */
	if (FileOpen(&fp, &(MenuWin->file_no), Pager, RMan, Menu, FSet)){
		/* եʳ(Type=1)ޤϥե뤬ĤʤȤ */
		SendPagerAllDraw(display, Pager->window);
		SendScrollAllDraw(display, Scroll->scrbar);
		SendMenuAllDraw(display, MenuWin->sw[0]);
		return;
	}

	/*  եɤ߹  */
	FileRead(fp, Pager, RMan->MaxLine, 8, True);

	FSet[MenuWin->file_no].file_table = 1;
	Pager->pos = FSet[MenuWin->file_no].file_pos;

	SendPagerAllDraw(display, Pager->window);
	SendMenuAllDraw(display, MenuWin->sw[0]);
}

MemStringCopy(char **string1, char *string2)
/*
	ݤơstring2string1˥ԡ
*/
{
	free(*string1);
	*string1 = (char *)malloc(strlen(string2)+1);
	strncpy(*string1, string2, strlen(string2)+1);
}

#ifdef nodef
GetWinXY(int *x, int *y, int width, int height)
{
	*x = GEO_X + (GEO_WID  / 2) - (width  / 2);
	*y = GEO_Y + (GEO_HEIT / 2) - (height / 2);

	if (*x < 0) *x = 0;
	if (*y < 0) *y = 0;
}
#endif

